/*
 * fly_behavior.hpp
 *
 *  Created on: 18 окт. 2021 г.
 *      Author: alexander
 */

#pragma once

#include <iostream>

class FlyBehavior
{
public:
    virtual void fly() = 0;
    virtual ~FlyBehavior() { }
};

class FlyWithWings : public FlyBehavior
{
public:
    void fly()
    {
        std::cout << "I'm flying!" << std::endl;
    }
};

class FlyNoWay : public FlyBehavior
{
public:
    void fly()
    {
        std::cout << "I can't fly" << std::endl;
    }
};

class FlyRocketPowered : public FlyBehavior
{
public:
    void fly()
    {
        std::cout << "I'm flying with a rocket!" << std::endl;
    }
};
